VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Player"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private m_board As Board
Private m_isWhite As Boolean
Private m_CountPawn As Byte
Private m_CountNonPawn As Byte
Private m_colPieces As Collection
Private m_colCaptures As Collection
Private m_PawnForwardOffset As Integer
Private m_PawnForward2Offset As Integer
Private m_PawnAttackRightOffset As Integer
Private m_PawnAttackLeftOffset As Integer
Private m_king As Piece
Private m_rookQueen As Piece
Private m_rookKing As Piece
Private m_hasCastled As Boolean
Private m_opponent As Player
Private m_listColoredSquare As New Collection

Private Sub Class_Initialize()
    m_CountPawn = 8
    m_CountNonPawn = 7
    Set m_colPieces = New Collection
    Set m_colCaptures = New Collection
    m_hasCastled = False
End Sub

Public Sub BuildPlayer(ByVal isWhite As Boolean, parent As Board, _
    ByVal val_PawnForwardOffset As Integer, ByVal val_PawnForward2Offset As Integer, _
    ByVal PawnAttackRightOffset As Integer, ByVal PawnAttackLeftOffset As Integer)
Dim indRank As Byte, indFile As Byte

    Set m_board = parent
    m_isWhite = isWhite
        
    indRank = IIf(m_isWhite, rank1, rank8)
    Set m_king = CreatePiece(fileE, indRank, typeKing, valueKing)
    CreatePiece fileD, indRank, typeQueen, valueQueen
    Set m_rookQueen = CreatePiece(fileA, indRank, typeRook, valueRook)
    Set m_rookKing = CreatePiece(fileH, indRank, typeRook, valueRook)
    CreatePiece fileC, indRank, typeBishop, valueBishop
    CreatePiece fileF, indRank, typeBishop, valueBishop
    CreatePiece fileB, indRank, typeKnight, valueKnight
    CreatePiece fileG, indRank, typeKnight, valueKnight
    
    indRank = IIf(m_isWhite, rank2, rank7)
    For indFile = fileA To fileH
        CreatePiece indFile, indRank, typePawn, valuePawn
    Next
    m_PawnForwardOffset = val_PawnForwardOffset
    m_PawnForward2Offset = val_PawnForward2Offset
    m_PawnAttackRightOffset = PawnAttackRightOffset
    m_PawnAttackLeftOffset = PawnAttackLeftOffset
End Sub

Public Sub FreePlayer()
Dim pieceThis As Piece, sqr As Square

    Set m_rookKing = Nothing
    Set m_rookQueen = Nothing
    Set m_king = Nothing
    For Each pieceThis In m_colCaptures
        Set pieceThis = Nothing
    Next
    For Each pieceThis In m_colPieces
        Set sqr = pieceThis.Square
        sqr.SetPieceSquare Nothing
        pieceThis.SetSquare Nothing
        Set pieceThis = Nothing
    Next
    Set m_colCaptures = Nothing
    Set m_colPieces = Nothing
    Set m_opponent = Nothing
    Set m_board = Nothing
End Sub

Private Function CreatePiece(ByVal fileOfPiece As Byte, ByVal rankOfPiece As Byte, _
            ByVal TypePiece As Byte, ByVal valueOfPiece As Integer) As Piece
Dim piecePlayer As Piece

    Set piecePlayer = New Piece
    piecePlayer.BuildPiece TypePiece, fileOfPiece, rankOfPiece, Me, valueOfPiece
    Set CreatePiece = piecePlayer
    
End Function

Public Property Get isWhite() As Boolean
    isWhite = m_isWhite
End Property

Public Property Get CountPawn() As Byte
    CountPawn = m_CountPawn
End Property

Public Sub CountPawnDecr()
    m_CountPawn = m_CountPawn - 1
End Sub

Public Sub CountPawnIncr()
    m_CountPawn = m_CountPawn + 1
End Sub

Public Sub CountNonPawnDecr()
    m_CountNonPawn = m_CountNonPawn - 1
End Sub

Public Sub CountNonPawnIncr()
    m_CountNonPawn = m_CountNonPawn + 1
End Sub

Public Property Get BoardChess() As Board
    Set BoardChess = m_board
End Property

Public Property Get OtherPlayer() As Player
    Set OtherPlayer = m_opponent
End Property

Public Sub SetOpponent(ByVal playerOpp As Player)
    Set m_opponent = playerOpp
End Sub

Public Property Get ListPiece() As Collection
    Set ListPiece = m_colPieces
End Property

Public Property Get ListCapture() As Collection
    Set ListCapture = m_colCaptures
End Property

Public Property Get HasCastled() As Boolean
    HasCastled = m_hasCastled
End Property

Public Property Let HasCastled(ByVal Value As Boolean)
    m_hasCastled = Value
End Property

Public Property Get PawnForwardOffset() As Integer
    PawnForwardOffset = m_PawnForwardOffset
End Property

Public Property Get PawnForward2Offset() As Integer
    PawnForward2Offset = m_PawnForward2Offset
End Property

Public Property Get PawnAttackRightOffset() As Integer
    PawnAttackRightOffset = m_PawnAttackRightOffset
End Property

Public Property Get PawnAttackLeftOffset() As Integer
    PawnAttackLeftOffset = m_PawnAttackLeftOffset
End Property

Public Property Get PieceKing() As Piece
    Set PieceKing = m_king
End Property

Public Sub GenAllLazyMoves(ByRef movesPossible As Collection)
Dim indPiece As Integer, pieceThis As Piece

    For indPiece = m_colPieces.Count To 1 Step -1
        Set pieceThis = m_colPieces(indPiece)
        pieceThis.GenerateLazyMoves movesPossible
    Next
End Sub

Public Function CanMove() As Boolean
Dim pieceThis As Piece

    For Each pieceThis In m_colPieces
        If pieceThis.IsLegalMove() Then
            CanMove = True: Exit Function
        End If
    Next
    CanMove = False
End Function

Public Function CanAttack(ByVal ordinalTarget As Byte) As Boolean
Dim pieceThis As Piece

    For Each pieceThis In m_colPieces
        If pieceThis.isAttacking(ordinalTarget) Then
            CanAttack = True: Exit Function
        End If
    Next
    CanAttack = False
End Function

Private Function Supporter(ByVal ordinalStart As Byte, ByVal offsetDirection As Integer, ByVal typeFriend As Byte) As Integer
Dim ordSqr As Byte, sqrThis As Square, pieceThis As Piece, typeOfPiece As Byte

    ordSqr = ordinalStart + offsetDirection
    Do
        Set sqrThis = m_board.GetSquare(ordSqr)
        If sqrThis Is Nothing Then
            Exit Do
        Else
            Set pieceThis = sqrThis.PieceOnSquare
            If Not pieceThis Is Nothing Then
                If pieceThis.isWhite = m_isWhite Then
                    typeOfPiece = pieceThis.TypePiece
                    If typeOfPiece = typeQueen Or typeOfPiece = typeFriend Then
                        Supporter = ordSqr: Exit Function
                    End If
                End If
                Exit Do
            End If
            ordSqr = ordSqr + offsetDirection
        End If
    Loop While True
    Supporter = 0
    
End Function

Private Function PieceOpponent(ByVal ordinalStart As Byte, ByVal offsetDirection As Integer) As Piece
Dim ordSqr As Byte, sqrThis As Square, pieceThis As Piece, typeOfPiece As Integer

    ordSqr = ordinalStart + offsetDirection
    Do
        Set sqrThis = m_board.GetSquare(ordSqr)
        If sqrThis Is Nothing Then
            Exit Do
        Else
            Set pieceThis = sqrThis.PieceOnSquare
            If Not pieceThis Is Nothing Then
                If pieceThis.isWhite <> m_isWhite Then
                   Set PieceOpponent = pieceThis: Exit Function
                End If
                Exit Do
            End If
            ordSqr = ordSqr + offsetDirection
        End If
    Loop While True
    Set PieceOpponent = Nothing
    
End Function

Public Function CountDefenderXray(ByVal ordinalTarget As Byte, ByVal typeFriend As Byte, ByRef valueDefenderSmaller As Integer) As Byte
Dim nbrDefender As Byte, pieceThis As Piece, typeOfPiece As Byte, ordDiff As Integer
Dim offsetDirection As Integer, ordinalDefender As Byte, isFriendSliding As Boolean

    nbrDefender = 0: valueDefenderSmaller = valueKing
    isFriendSliding = typeFriend = typeQueen Or typeFriend = typeRook Or typeFriend = typeBishop
    For Each pieceThis In m_colPieces
        If pieceThis.isDefending(ordinalTarget) Then
            nbrDefender = nbrDefender + 1
            If pieceThis.ValuePiece < valueDefenderSmaller Then
                valueDefenderSmaller = pieceThis.ValuePiece
            End If
            typeOfPiece = pieceThis.TypePiece
            Select Case typeOfPiece
            Case typeBishop
                ordinalDefender = pieceThis.Square.Ordinal
                offsetDirection = offsetBishopAttacking(offsetDiffOrdinal + ordinalDefender - ordinalTarget)
                
            Case typeRook
                ordinalDefender = pieceThis.Square.Ordinal
                offsetDirection = offsetRookAttacking(offsetDiffOrdinal + ordinalDefender - ordinalTarget)
                
            Case typeQueen
                ordinalDefender = pieceThis.Square.Ordinal
                ordDiff = offsetDiffOrdinal + ordinalDefender - ordinalTarget
                offsetDirection = offsetQueenAttacking(ordDiff)
                typeOfPiece = IIf(offsetDirection = offsetBishopAttacking(ordDiff), typeBishop, typeRook)
            
            Case Else
                ordinalDefender = 0
            End Select
            While ordinalDefender > 0
                ordinalDefender = Supporter(ordinalDefender, offsetDirection, typeOfPiece)
                If ordinalDefender > 0 Then
                    nbrDefender = nbrDefender + 1
                End If
            Wend
        ElseIf isFriendSliding Then
            Select Case pieceThis.TypePiece
            Case typeBishop
                ordinalDefender = pieceThis.Square.Ordinal
                offsetDirection = offsetBishopAttacking(offsetDiffOrdinal + ordinalTarget - ordinalDefender)
                
            Case typeRook
                ordinalDefender = pieceThis.Square.Ordinal
                offsetDirection = offsetRookAttacking(offsetDiffOrdinal + ordinalTarget - ordinalDefender)
                
            Case typeQueen
                ordinalDefender = pieceThis.Square.Ordinal
                offsetDirection = offsetQueenAttacking(offsetDiffOrdinal + ordinalTarget - ordinalDefender)
            
            Case Else
                offsetDirection = 0
            End Select
            If offsetDirection <> 0 Then
                If pieceThis.IsDefenseXray(ordinalTarget, offsetDirection) Then
                    nbrDefender = nbrDefender + 1
                End If
            End If
        End If
    Next
    If nbrDefender = 0 Then
        valueDefenderSmaller = 0
    End If
    CountDefenderXray = nbrDefender
    
End Function

Public Sub PiecesPinnedSearch()
Dim piecePin As Piece, ordPin As Byte, ordKing As Byte, offsetDirKing As Integer
Dim pieceOpp As Piece, ordOpp As Byte, offsetDirOpp As Integer
    
    ordKing = m_king.Square.Ordinal
    For Each piecePin In m_colPieces
        ordPin = piecePin.Square.Ordinal
        If ordPin <> ordKing Then
            piecePin.OffsetPinAbsolute = 0
            offsetDirKing = offsetQueenAttacking(offsetDiffOrdinal + ordKing - ordPin)
            If offsetDirKing <> 0 Then
                If m_board.IsRayEmpty(ordPin, ordKing, offsetDirKing) Then
                    For Each pieceOpp In OtherPlayer.ListPiece
                        Select Case pieceOpp.TypePiece
                        Case typeBishop
                            ordOpp = pieceOpp.Square.Ordinal
                            offsetDirOpp = offsetBishopAttacking(offsetDiffOrdinal + ordPin - ordOpp)
                            
                        Case typeRook
                            ordOpp = pieceOpp.Square.Ordinal
                            offsetDirOpp = offsetRookAttacking(offsetDiffOrdinal + ordPin - ordOpp)
                            
                        Case typeQueen
                            ordOpp = pieceOpp.Square.Ordinal
                            offsetDirOpp = offsetQueenAttacking(offsetDiffOrdinal + ordPin - ordOpp)
                        
                        Case Else
                            offsetDirOpp = 0
                        End Select
                        If offsetDirKing = offsetDirOpp Then
                            If m_board.IsRayEmpty(ordOpp, ordPin, offsetDirKing) Then
                                piecePin.OffsetPinAbsolute = offsetDirKing
                                Exit For
                            End If
                        End If
                    Next
                End If
            End If
        End If
    Next
End Sub

Public Function CountAttackerPin(ByVal ordinalTarget As Byte, ByRef valueAttackerSmaller As Integer, _
        ByRef offsetOfPinAbsolute As Integer, ByRef offsetOfPinRelative As Integer) As Byte
Dim pieceThis As Piece, typeOfPiece As Integer, isAttack As Boolean, piecePinTarget As Piece
Dim offsetDirAttack As Integer, ordinalAttacker As Byte, offsetDirKing As Integer, ordKingOpp As Byte
Dim ordDiff As Integer, nbrAttack As Byte

    nbrAttack = 0: valueAttackerSmaller = valueKing
    offsetOfPinAbsolute = 0: offsetOfPinRelative = 0
    For Each pieceThis In m_colPieces
        If pieceThis.OffsetPinAbsolute <> 0 Then
            If pieceThis.TypePiece = typeKnight Then
                isAttack = False
            Else
                isAttack = pieceThis.isCounterAttackPin(ordinalTarget, pieceThis.OffsetPinAbsolute)
            End If
        Else
            isAttack = pieceThis.isAttacking(ordinalTarget)
        End If
        If isAttack Then
            nbrAttack = nbrAttack + 1
            If pieceThis.ValuePiece < valueAttackerSmaller Then
                valueAttackerSmaller = pieceThis.ValuePiece
            End If
            typeOfPiece = pieceThis.TypePiece
            Select Case typeOfPiece
            Case typeBishop
                ordinalAttacker = pieceThis.Square.Ordinal
                offsetDirAttack = offsetBishopAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                
            Case typeRook
                ordinalAttacker = pieceThis.Square.Ordinal
                offsetDirAttack = offsetRookAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                
            Case typeQueen
                ordinalAttacker = pieceThis.Square.Ordinal
                ordDiff = offsetDiffOrdinal + ordinalTarget - ordinalAttacker
                offsetDirAttack = offsetQueenAttacking(ordDiff)
                typeOfPiece = IIf(offsetDirAttack = offsetBishopAttacking(ordDiff), typeBishop, typeRook)
            
            Case Else
                ordinalAttacker = 0
            End Select
            If ordinalAttacker > 0 Then
                Set piecePinTarget = PieceOpponent(ordinalTarget, offsetDirAttack)
                If Not piecePinTarget Is Nothing Then
                    If piecePinTarget.TypePiece = typeKing Then
                        offsetOfPinAbsolute = offsetDirAttack
                    ElseIf piecePinTarget.ValuePiece - pieceThis.ValuePiece > valuePawn Then
                        offsetOfPinRelative = offsetDirAttack
                    End If
                End If
                While ordinalAttacker > 0
                    ordinalAttacker = Supporter(ordinalAttacker, -offsetDirAttack, typeOfPiece)
                    If ordinalAttacker > 0 Then
                        nbrAttack = nbrAttack + 1
                    End If
                Wend
            End If
        End If
    Next
    If offsetOfPinAbsolute <> 0 Then
        offsetOfPinRelative = 0
    End If
    If nbrAttack = 0 Then
        valueAttackerSmaller = 0
    End If
    CountAttackerPin = nbrAttack
    
End Function

Public Function AttackerSmaller(ByVal ordinalTarget As Byte, ByRef nbrAttack As Byte) As Piece
Dim pieceThis As Piece, typeOfPiece As Byte, pieceSmaller As Piece, isAttack As Boolean
Dim offsetDirAttack As Integer, ordinalAttacker As Byte, ordDiff As Integer

    Set pieceSmaller = Nothing
    nbrAttack = 0
    For Each pieceThis In m_colPieces
        If pieceThis.OffsetPinAbsolute <> 0 Then
            If pieceThis.TypePiece = typeKnight Then
                isAttack = False
            Else
                isAttack = pieceThis.isCounterAttackPin(ordinalTarget, pieceThis.OffsetPinAbsolute)
            End If
        Else
            isAttack = pieceThis.isAttacking(ordinalTarget)
        End If
        If isAttack Then
            nbrAttack = nbrAttack + 1
            If pieceSmaller Is Nothing Then
                Set pieceSmaller = pieceThis
            ElseIf pieceThis.ValuePiece < pieceSmaller.ValuePiece Then
                Set pieceSmaller = pieceThis
            End If
            typeOfPiece = pieceThis.TypePiece
            Select Case typeOfPiece
            Case typeBishop
                ordinalAttacker = pieceThis.Square.Ordinal
                offsetDirAttack = offsetBishopAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                
            Case typeRook
                ordinalAttacker = pieceThis.Square.Ordinal
                offsetDirAttack = offsetRookAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                
            Case typeQueen
                ordinalAttacker = pieceThis.Square.Ordinal
                ordDiff = offsetDiffOrdinal + ordinalTarget - ordinalAttacker
                offsetDirAttack = offsetQueenAttacking(ordDiff)
                typeOfPiece = IIf(offsetDirAttack = offsetBishopAttacking(ordDiff), typeBishop, typeRook)
            
            Case Else
                ordinalAttacker = 0
            End Select
            While ordinalAttacker > 0
                ordinalAttacker = Supporter(ordinalAttacker, -offsetDirAttack, typeOfPiece)
                If ordinalAttacker > 0 Then
                    nbrAttack = nbrAttack + 1
                End If
            Wend
        End If
    Next
    Set AttackerSmaller = pieceSmaller
    
End Function

Public Function CountAttackerNoPin(ByVal ordinalTarget As Byte, ByVal isKing As Boolean, ByRef valueAttackerSmaller As Integer) As Byte
Dim pieceThis As Piece, typeOfPiece As Byte, isAttack As Boolean, ordDiff As Integer
Dim offsetDirAttack As Integer, ordinalAttacker As Byte, nbrAttack As Byte

    nbrAttack = 0: valueAttackerSmaller = valueKing
    For Each pieceThis In m_colPieces
        typeOfPiece = pieceThis.TypePiece
        If (typeOfPiece <> typeKing And Not isKing) Or isKing Then
            If pieceThis.OffsetPinAbsolute <> 0 Then
                If pieceThis.TypePiece = typeKnight Then
                    isAttack = False
                Else
                    isAttack = pieceThis.isCounterAttackPin(ordinalTarget, pieceThis.OffsetPinAbsolute)
                End If
            Else
                isAttack = pieceThis.isAttacking(ordinalTarget)
            End If
            If isAttack Then
                If pieceThis.ValuePiece < valueAttackerSmaller Then
                    valueAttackerSmaller = pieceThis.ValuePiece
                End If
                nbrAttack = nbrAttack + 1
                Select Case typeOfPiece
                Case typeBishop
                    ordinalAttacker = pieceThis.Square.Ordinal
                    offsetDirAttack = offsetBishopAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                    
                Case typeRook
                    ordinalAttacker = pieceThis.Square.Ordinal
                    offsetDirAttack = offsetRookAttacking(offsetDiffOrdinal + ordinalTarget - ordinalAttacker)
                    
                Case typeQueen
                    ordinalAttacker = pieceThis.Square.Ordinal
                    ordDiff = offsetDiffOrdinal + ordinalTarget - ordinalAttacker
                    offsetDirAttack = offsetQueenAttacking(ordDiff)
                    typeOfPiece = IIf(offsetDirAttack = offsetBishopAttacking(ordDiff), typeBishop, typeRook)
                
                Case Else
                    ordinalAttacker = 0
                End Select
                While ordinalAttacker > 0
                    ordinalAttacker = Supporter(ordinalAttacker, -offsetDirAttack, typeOfPiece)
                    If ordinalAttacker > 0 Then
                        nbrAttack = nbrAttack + 1
                    End If
                Wend
            End If
        End If
    Next
    If nbrAttack = 0 Then
        valueAttackerSmaller = 0
    End If
    CountAttackerNoPin = nbrAttack
    
End Function

Public Property Get RookQ() As Piece
    Set RookQ = m_rookQueen
End Property

Public Property Get RookK() As Piece
    Set RookK = m_rookKing
End Property

Public Function CanKingGoTo(ByVal sqrTo As Square) As Boolean
Dim pieceCapture As Piece, isKingCheck As Boolean, sqrKing As Square

    If sqrTo Is Nothing Then
        CanKingGoTo = False: Exit Function
    End If
    Set pieceCapture = sqrTo.PieceOnSquare
    If Not pieceCapture Is Nothing Then
        If pieceCapture.isWhite = m_isWhite Then
            CanKingGoTo = False: Exit Function
        End If
    End If
    Set sqrKing = m_king.Square
    sqrKing.SetPieceSquare Nothing
    isKingCheck = OtherPlayer.CanAttack(sqrTo.Ordinal)
    sqrKing.SetPieceSquare m_king
    
    CanKingGoTo = Not isKingCheck
    
End Function

Public Function CouldCastleQueenSide() As Boolean
    If m_king.HasMoved Then
        CouldCastleQueenSide = False
    Else
        CouldCastleQueenSide = Not m_rookQueen.HasMoved
    End If
End Function

Public Function CouldCastleKingSide() As Boolean
    If m_king.HasMoved Then
        CouldCastleKingSide = False
    Else
        CouldCastleKingSide = Not m_rookKing.HasMoved
    End If
End Function

Public Function CanCastleKingSide() As Boolean
Dim opponent As Player

    If CouldCastleKingSide() Then
        If m_isWhite Then
            If m_board.IsRayEmpty(e1, h1, 1) Then
                Set opponent = OtherPlayer
                If Not opponent.CanAttack(f1) Then
                    If Not opponent.CanAttack(g1) Then
                        CanCastleKingSide = True: Exit Function
                    End If
                End If
            End If
        Else
            If m_board.IsRayEmpty(e8, h8, 1) Then
                Set opponent = OtherPlayer
                If Not opponent.CanAttack(f8) Then
                    If Not opponent.CanAttack(g8) Then
                        CanCastleKingSide = True: Exit Function
                    End If
                End If
            End If
        End If
    End If
    CanCastleKingSide = False
End Function

Public Function CanCastleQueenSide() As Boolean
Dim opponent As Player

    If CouldCastleQueenSide() Then
        If m_isWhite Then
            If m_board.IsRayEmpty(e1, a1, -1) Then
                Set opponent = OtherPlayer
                If Not opponent.CanAttack(d1) Then
                    If Not opponent.CanAttack(c1) Then
                        CanCastleQueenSide = True: Exit Function
                    End If
                End If
            End If
        Else
            If m_board.IsRayEmpty(e8, a8, -1) Then
                Set opponent = OtherPlayer
                If Not opponent.CanAttack(d8) Then
                    If Not opponent.CanAttack(c8) Then
                        CanCastleQueenSide = True: Exit Function
                    End If
                End If
            End If
        End If
    End If
    CanCastleQueenSide = False
End Function

Public Function IsInCheck() As Boolean
    IsInCheck = OtherPlayer.CanAttack(m_king.Square.Ordinal)
End Function

Public Function Status() As Byte
    If CanMove() Then
        Status = IIf(IsInCheck(), statusInCheck, statusNormal)
    Else
        Status = IIf(IsInCheck(), statusInCheckMate, statusDrawStaleMate)
    End If
End Function

Public Function StatusLastMove(ByVal isCheck As Boolean) As Byte
    If CanMove() Then
        StatusLastMove = IIf(isCheck, statusInCheck, statusNormal)
    Else
        StatusLastMove = IIf(isCheck, statusInCheckMate, statusDrawStaleMate)
    End If
End Function

Private Function PgnCastle(ByVal strSan As String, _
                    ByRef sqrTo As Square, ByRef TypeOfMove As Byte) As Boolean
Dim strSanUpper As String

    strSanUpper = UCase(strSan)
    If strSanUpper = "OO" Or strSanUpper = "O-O" Then
        Set sqrTo = m_board.GetSquare(m_king.Square.Ordinal + 2)
        If sqrTo Is Nothing Then
            PgnCastle = False: Exit Function
        End If
        TypeOfMove = moveCastleKingSide
    ElseIf strSanUpper = "OOO" Or strSanUpper = "O-O-O" Then
        Set sqrTo = m_board.GetSquare(m_king.Square.Ordinal - 2)
        If sqrTo Is Nothing Then
            PgnCastle = False: Exit Function
        End If
        TypeOfMove = moveCastleQueenSide
    Else
        PgnCastle = False: Exit Function
    End If
    PgnCastle = True
End Function

Private Function PgnPawnForward(ByVal ordinalTo As Byte, ByRef pieceThis As Piece) As Boolean
Dim sqrFrom As Square

    PgnPawnForward = False
    Set sqrFrom = m_board.GetSquare(ordinalTo - m_PawnForwardOffset)
    If sqrFrom Is Nothing Then
        Exit Function
    End If

    Set pieceThis = sqrFrom.PieceOnSquare
    If pieceThis Is Nothing Then
        Set sqrFrom = m_board.GetSquare(ordinalTo - m_PawnForward2Offset)
        If sqrFrom Is Nothing Then
            Exit Function
        End If
        Set pieceThis = sqrFrom.PieceOnSquare
    End If
    If pieceThis Is Nothing Then
        Exit Function
    End If
    If pieceThis.TypePiece <> typePawn Then
        Exit Function
    End If
    If pieceThis.isWhite <> m_isWhite Then
        Exit Function
    End If
    PgnPawnForward = True
End Function

Private Function PgnPawnCapture(ByVal ordinalTo As Byte, _
                    ByRef fromFile As Byte, ByRef fromRank As Byte, _
                    ByRef pieceTaken As Piece, ByRef TypeOfMove As Byte) As Boolean
Dim sqrFrom As Square, pieceThis As Piece, sqrPawnTaken As Square

    PgnPawnCapture = False
    If fromFile = -1 And fromRank = -1 Then
        Set sqrFrom = m_board.GetSquare(ordinalTo - m_PawnAttackLeftOffset)
        If sqrFrom Is Nothing Then
            Set sqrFrom = m_board.GetSquare(ordinalTo - m_PawnAttackRightOffset)
        ElseIf sqrFrom.IsEmpty() Then
            Set sqrFrom = m_board.GetSquare(ordinalTo - m_PawnAttackRightOffset)
        End If
        If sqrFrom Is Nothing Then
            Exit Function
        End If
        If sqrFrom.IsEmpty() Then
            Exit Function
        End If
        fromFile = sqrFrom.File
        fromRank = sqrFrom.Rank
        Set pieceThis = sqrFrom.PieceOnSquare
        If pieceThis.TypePiece <> typePawn Then
            Exit Function
        End If
        If pieceThis.isWhite <> m_isWhite Then
            Exit Function
        End If
    Else
        If pieceTaken Is Nothing Then
            TypeOfMove = moveEnPassant
            Set sqrPawnTaken = m_board.GetSquare(ordinalTo + IIf(m_isWhite, -16, 16))
            If sqrPawnTaken Is Nothing Then
                Exit Function
            End If
            Set pieceTaken = sqrPawnTaken.PieceOnSquare
            If pieceTaken Is Nothing Then
                Exit Function
            End If
            If pieceTaken.isWhite = m_isWhite Then
                Exit Function
            End If
        End If
    End If
    PgnPawnCapture = True
End Function

Public Sub MoveFromStringSan(ByVal strSan As String, ByVal nbrTry As Byte, ByRef moveThis As Move)
Dim TypeOfMove As Byte, isCapture As Boolean, sqrTo As Square
Dim pieceThis As Piece, pieceTaken As Piece, typeOfPiece As Byte, charCheck As String
Dim indPos As Integer, fromRank As Byte, fromFile As Byte
Dim strChar As String, pieceList As Collection
Dim nbrAttempt As Byte, pieceCandidate As Piece

    Set moveThis = Nothing
    TypeOfMove = moveStandard
    Set pieceThis = Nothing: Set pieceTaken = Nothing
    fromFile = 0: fromRank = 0
    isCapture = False
    strSan = Trim(strSan)
    indPos = Len(strSan)
    charCheck = Mid(strSan, indPos, 1)
    If charCheck = "+" Or charCheck = "#" Then
        indPos = indPos - 1
    End If
    If indPos > 2 Then
        If Mid(strSan, indPos - 1, 1) = "=" Then
            strChar = Mid(strSan, indPos, 1)
            indPos = indPos - 1
            If Not AbbrToTypePromotion(strChar, TypeOfMove) Then ErrWarn 4000
            indPos = indPos - 1
        End If
    End If
    If Left(strSan, 1) = "O" Then
        If Not PgnCastle(strSan, sqrTo, TypeOfMove) Then
            Exit Sub
        End If
        Set pieceThis = m_king
    ElseIf Left(strSan, 1) = "0" Then ErrWarn 4010
    Else
        indPos = indPos - 1
        Set sqrTo = m_board.GetSquareSan(Mid(strSan, indPos, 2))
        If sqrTo Is Nothing Then ErrWarn 4020
        Set pieceTaken = sqrTo.PieceOnSquare
        indPos = indPos - 1
        If indPos > 0 Then
            strChar = LCase(Mid(strSan, indPos, 1))
            If strChar = "x" Then
                indPos = indPos - 1
                isCapture = True
            End If
        End If
        If Not pieceTaken Is Nothing And Not isCapture Then ErrWarn 4040
        
        If indPos > 0 Then
            strChar = Mid(strSan, indPos, 1)
            If IsNumeric(strChar) Then
                fromRank = RankFromName(strChar)
                If fromRank = 0 Then ErrWarn 4050
                indPos = indPos - 1
            End If
        End If
        
        If indPos > 0 Then
            strChar = Mid(strSan, indPos, 1)
            If strChar >= "a" And strChar <= "h" Then
                fromFile = FileFromName(strChar)
                If fromFile = 0 Then ErrWarn 4060
                indPos = indPos - 1
            End If
        End If
        
        If indPos > 0 Then
            strChar = Mid(strSan, indPos, 1)
        Else
            strChar = "P"
        End If
        If Not AbbrToTypePiece(strChar, typeOfPiece) Then ErrWarn 4070
        
        If typeOfPiece = typePawn And Not isCapture Then
            If Not PgnPawnForward(sqrTo.Ordinal, pieceThis) Then ErrWarn 4080
        Else
            If isCapture Then
                If typeOfPiece = typePawn Then
                    If Not PgnPawnCapture(sqrTo.Ordinal, _
                            fromFile, fromRank, pieceTaken, TypeOfMove) Then ErrWarn 4090
                End If
                If pieceTaken Is Nothing Then ErrWarn 4100
                If pieceTaken.isWhite = m_isWhite Then ErrWarn 4110
            End If
            Set pieceList = sqrTo.AttackerPieceList(Me)
            nbrAttempt = 0
            For Each pieceCandidate In pieceList
                If pieceCandidate.TypePiece = typeOfPiece And _
                    ((fromFile = 0) Or (fromFile = pieceCandidate.Square.File)) And _
                    ((fromRank = 0) Or (fromRank = pieceCandidate.Square.Rank)) Then
                    If nbrAttempt = nbrTry Or fromFile > 0 Or fromRank > 0 Then
                        nbrAttempt = nbrAttempt + 1
                        Set pieceThis = pieceCandidate
                        Exit For
                    End If
                End If
            Next
            Set pieceList = Nothing
        End If
    End If
    If pieceThis Is Nothing Then ErrWarn 4120
    Set moveThis = New Move
    moveThis.BuildMove TypeOfMove, pieceThis, pieceThis.Square, sqrTo, pieceTaken
    
End Sub

Public Function MoveFromStringDescr(ByVal strMove As String) As Move
Dim TypeOfMove As Byte, isCapture As Boolean, sqrFrom As Square, sqrTo As Square
Dim pieceThis As Piece, pieceTaken As Piece, typeOfPiece As Byte, charCheck As String
Dim indPos As Byte, strChar As String, moveThis As Move

    Set moveThis = Nothing
    TypeOfMove = moveStandard
    Set pieceThis = Nothing: Set pieceTaken = Nothing
    isCapture = False
    strMove = Trim(strMove)
    indPos = Len(strMove)
    charCheck = Mid(strMove, indPos, 1)
    If charCheck = "+" Or charCheck = "#" Then
        indPos = indPos - 1
    End If
    If indPos > 4 Then
        strChar = Mid(strMove, indPos, 1)
        If AbbrToTypePromotion(strChar, TypeOfMove) Then
            indPos = indPos - 1
        End If
    End If
    If Left(strMove, 1) = "O" Then
        If Not PgnCastle(strMove, sqrTo, TypeOfMove) Then
            Exit Function
        End If
        Set pieceThis = m_king
    ElseIf Left(strMove, 1) = "0" Then ErrWarn 4500
    Else
        indPos = indPos - 1
        Set sqrTo = m_board.GetSquareSan(Mid(strMove, indPos, 2))
        If sqrTo Is Nothing Then ErrWarn 4510
        Set pieceTaken = sqrTo.PieceOnSquare
        indPos = indPos - 1
        If indPos > 0 Then
            strChar = LCase(Mid(strMove, indPos, 1))
            If strChar = "x" Then
                indPos = indPos - 1
                isCapture = True
            End If
        End If
        If pieceTaken Is Nothing And isCapture Then ErrWarn 4520
        If Not pieceTaken Is Nothing And Not isCapture Then ErrWarn 4530
        
        If indPos > 1 Then
            indPos = indPos - 1
            Set sqrFrom = m_board.GetSquareSan(Mid(strMove, indPos, 2))
            If sqrFrom Is Nothing Then ErrWarn 4540
            indPos = indPos - 1
        End If
                
        If indPos > 0 Then
            strChar = Mid(strMove, indPos, 1)
        Else
            strChar = "P"
        End If
        If Not AbbrToTypePiece(strChar, typeOfPiece) Then ErrWarn 4550
        
        If isCapture Then
            If pieceTaken Is Nothing Then ErrWarn 4560
            If pieceTaken.isWhite = m_isWhite Then ErrWarn 4570
        End If
        Set pieceThis = sqrFrom.PieceOnSquare
    End If
    If pieceThis Is Nothing Then ErrWarn 4580
    Set moveThis = New Move
    moveThis.BuildMove TypeOfMove, pieceThis, pieceThis.Square, sqrTo, pieceTaken
    Set MoveFromStringDescr = moveThis
    
End Function

Public Property Get ListColoredSquare() As Collection
    Set ListColoredSquare = m_listColoredSquare
End Property

Public Function KnightFork(ByVal ordinalFrom As Byte, ByRef valueForkTarget As Integer, ByRef ordForkThreat As Byte) As Integer
Dim sqrTo As Square, indOffset As Byte, pieceCapture As Piece, nbrCapture As Byte
Dim valueFork1 As Integer, ordFork1 As Byte
Dim valueFork2 As Integer, ordFork2 As Byte, ordForkTarget As Byte, ordRookExclude As Byte

    nbrCapture = 0: valueForkTarget = 0
    valueFork1 = 0: valueFork2 = 0: ordFork1 = 0: ordFork2 = 0: ordForkTarget = 0: ordForkThreat = 0
    For indOffset = 1 To nbrOffsetKnight
        Set sqrTo = m_board.GetSquare(ordinalFrom + offsetKnight(indOffset))
        If Not sqrTo Is Nothing Then
            Set pieceCapture = sqrTo.PieceOnSquare
            If Not pieceCapture Is Nothing Then
                If pieceCapture.isWhite <> m_isWhite Then
                    nbrCapture = nbrCapture + 1
                    If pieceCapture.ValuePiece > valueFork1 Then
                        If valueFork1 > valueFork2 Then
                            valueFork2 = valueFork1
                            ordFork2 = ordFork1
                        End If
                        valueFork1 = pieceCapture.ValuePiece
                        ordFork1 = pieceCapture.Square.Ordinal
                    ElseIf pieceCapture.ValuePiece > valueFork2 Then
                        valueFork2 = pieceCapture.ValuePiece
                        ordFork2 = pieceCapture.Square.Ordinal
                    End If
                End If
            End If
        End If
    Next
    If nbrCapture > 1 Then
        If valueFork1 >= valueRook And valueFork2 <> valueKnight Then
            ordForkTarget = ordFork2
            valueForkTarget = valueFork2
            ordRookExclude = IIf(valueFork1 = valueRook, ordFork1, 0)
            If ordRookExclude = 0 Then
                ordRookExclude = IIf(valueFork2 = valueRook, ordFork2, 0)
            End If
            ordForkThreat = KnightThreatRook(ordinalFrom, ordRookExclude)
        End If
    ElseIf nbrCapture = 1 Then
        If valueFork1 >= valueRook Then
            ordRookExclude = IIf(valueFork1 = valueRook, ordFork1, 0)
            ordForkThreat = KnightThreatRook(ordinalFrom, ordRookExclude)
        End If
    End If
    KnightFork = ordForkTarget
    
End Function

Private Function KnightThreatRook(ByVal ordinalFrom As Byte, ByVal ordRookExclude As Byte)
Dim sqrTo As Square, indOffset As Integer, ordSqrTo As Byte, ordRook1 As Byte, ordRook2 As Byte
Dim offsetDirection As Integer, offsetCandidate As Integer, ordSqrCandidate As Byte
Dim distKingCandidate As Byte, distKingTo As Byte

    ordSqrCandidate = 0: offsetCandidate = 0: distKingCandidate = countRank + countFile
    If m_opponent.RookSearch(ordRookExclude, ordRook1, ordRook2) Then
        For indOffset = 1 To nbrOffsetKnight
            Set sqrTo = m_board.GetSquare(ordinalFrom + offsetKnight(indOffset))
            If Not sqrTo Is Nothing Then
                If sqrTo.IsEmpty() Then
                    ordSqrTo = sqrTo.Ordinal
                    offsetDirection = offsetRookAttacking(offsetDiffOrdinal + ordRook1 - ordSqrTo)
                    If offsetDirection = 0 And ordRook2 > 0 Then
                        ordRook1 = ordRook2
                        offsetDirection = offsetRookAttacking(offsetDiffOrdinal + ordRook1 - ordSqrTo)
                    End If
                    If offsetDirection <> 0 Then
                        If m_board.IsRayEmpty(ordSqrTo, ordRook1, offsetDirection) Then
                            distKingTo = m_opponent.ManhattanDistanceKing(ordSqrTo)
                            If distKingTo < distKingCandidate Then
                                ordSqrCandidate = ordSqrTo
                                offsetCandidate = offsetDirection
                                distKingCandidate = distKingTo
                            End If
                        End If
                    End If
                End If
            End If
        Next
    End If
    KnightThreatRook = ordSqrCandidate
    
End Function

Public Function RookSearch(ByVal ordRookExclude As Byte, ByRef ordRook1 As Byte, ByRef ordRook2 As Byte) As Boolean
Dim pieceThis As Piece

    ordRook1 = 0: ordRook2 = 0
    If m_rookKing.IsInPlay Then
        ordRook1 = m_rookKing.Square.Ordinal
    End If
    If m_rookQueen.IsInPlay Then
        ordRook2 = ordRook1
        ordRook1 = m_rookQueen.Square.Ordinal
    End If
    If ordRook1 = ordRookExclude Then
        ordRook1 = ordRook2
        ordRook2 = 0
    End If
    If ordRook2 = ordRookExclude Then
        ordRook2 = 0
    End If
    RookSearch = ordRook1 > 0 Or ordRook2 > 0
    
End Function

Public Function ManhattanDistanceKing(ByVal ordSqr As Byte) As Byte
Dim rankSqr As Integer, fileSqr As Integer
Dim rankKing As Byte, fileKing As Byte, ordKing As Integer

    ordKing = m_opponent.PieceKing.Square.Ordinal
    rankKing = RankFromOrdinal(ordKing)
    fileKing = FileFromOrdinal(ordKing)
    rankSqr = RankFromOrdinal(ordSqr)
    fileSqr = FileFromOrdinal(ordSqr)
    ManhattanDistanceKing = Abs(rankKing - rankSqr) + Abs(fileKing - fileSqr)
    
End Function

Public Function SumValuePiece() As Integer
Dim pieceThis As Piece, sumPieces As Integer

    sumPieces = 0
    For Each pieceThis In m_colPieces
        If pieceThis.TypePiece <> typeKing And pieceThis.TypePiece <> typePawn Then
            sumPieces = sumPieces + pieceThis.ValuePiece
        End If
    Next
    SumValuePiece = sumPieces
    
End Function






